/**************************************************************************
 *
 *  Copyright (C) 2001-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Convertisseur.
 *
 *	Convertisseur is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Convertisseur is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/
 

#define OPTIMIZE_ROM_CALLS
#define NO_EXIT_SUPPORT
#define NO_CALC_DETECT
#define NO_AMS_CHECK

#define USE_TI89
#define USE_TI92PLUS
#define USE_V200

#include <tigcclib.h>


/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

unsigned short var_len(char *var)
{
	return (2+*(unsigned short*)var) ;
}

/////////////////////////////////////////////////////////////////////////////////////////

char *mk_nam(char *str)
{
	static char name[19] = {0} ;
	short len = strlen(str) ;

	if (len > 17) return NULL ;

	return strcpy(name+1, str)+len ;
}

/////////////////////////////////////////////////////////////////////////////////////////

SYM_ENTRY *get_entry(char *str)
{
	char *nom = mk_nam(str) ;

	return SymFindPtr(nom, 0) ;
}

/////////////////////////////////////////////////////////////////////////////////////////

char *get_ptr(SYM_ENTRY *entry)
{
	if (entry == NULL || entry->handle == H_NULL) return NULL ;
	return (char*)HeapDeref(entry->handle) ;
}

/////////////////////////////////////////////////////////////////////////////////////////

void check(char *str)
{
	SYM_ENTRY *entry = get_entry(str) ;

	if (entry != NULL && entry->flags.bits.archived != 0)
	{
		EM_moveSymFromExtMem(mk_nam(str), HS_NULL) ;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////

char *mk_ptr(char *str, unsigned short taille)
{
	char *nom = mk_nam(str) ;
	SYM_ENTRY *entry ;

	check(str) ;

	entry = DerefSym(SymAdd(nom)) ;
	if (entry == NULL) return NULL ;

	nom = (char*)HeapDeref(entry->handle = HeapAlloc(taille)) ;
	if (entry->handle == H_NULL) return NULL ;

	*(unsigned short*)nom = taille-2 ;

	return (nom+2) ;
}

/////////////////////////////////////////////////////////////////////////////////////////

char *mk_perso_ptr(char *str, char *extension, unsigned short taille)
{
	unsigned char *var = mk_ptr(str, taille) ;

	if (var == NULL) return NULL ;

	*(var+taille-strlen(extension)-5) = 0 ;
	strcpy(var+taille-strlen(extension)-4, extension) ;
	*(var+taille-3) = OTH_TAG ;

	return var ;
}

/////////////////////////////////////////////////////////////////////////////////////////

unsigned char *get_ligne(unsigned char *var, short num)
{
	short i = 0 ;
	unsigned char *n, *n2, *limite = var+var_len(var)-1 ;

	for (n = n2 = var+5 ; n < limite ; n++)
	{
		if (*n == 13)
		{
			if (n == n2) i-- ;
			if (i++ == num) return n2 ;
			n2 = n+2 ;
		}
	}
	if (i == num) return n2 ;
	return NULL ;
}

/////////////////////////////////////////////////////////////////////////////////////////

short ligne_tampon(unsigned char *txt, unsigned char *ligne, short num)
{
	unsigned char *lign ;

	lign = get_ligne(txt, num) ;
	if (lign == NULL) return 0 ;
	memcpy(ligne, lign, 500) ;
	lign = ligne ;
	while (*lign++ != 13) ; *(lign-1) = 0 ;
	return 1 ;
}
